package weaverjn.action.common;

package ..deTemp.1748572009273;

import com.engine.edc.biz.form.FormNameBiz;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.commons.lang.StringEscapeUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.company.DepartmentComInfo;
import weaver.hrm.resource.ResourceComInfo;
import weaver.integration.logging.Logger;
import weaver.integration.logging.LoggerFactory;
import weaver.interfaces.workflow.action.Action;
import weaver.soa.workflow.request.Log;
import weaver.soa.workflow.request.RequestInfo;
import weaver.soa.workflow.request.RequestLog;
import weaver.workflow.request.RequestManager;
import weaver.workflow.workflow.WorkflowNodeComInfo;
import weaverjn.util.SapUtil;
import weaverjn.yksap.si_result_out_syn.MT_RESULT_REQ;
import weaverjn.yksap.si_result_out_syn.REQUEST_INFO;
import weaverjn.yksap.si_result_out_syn.REQUEST_LOG;

public class ActionMT_RESULT_REQ extends BaseBean implements Action {
  private String confid;
  
  public String execute(RequestInfo requestInfo) {
    String requestid = requestInfo.getRequestid();
    String workflowid = requestInfo.getWorkflowid();
    RequestManager rm = requestInfo.getRequestManager();
    if (Util.null2String(this.confid).isEmpty()) {
      rm.setMessageid(requestid);
      rm.setMessagecontent("节点动作ActionMT_RESULT_REQ参数错误");
      return "0";
    } 
    int formid = rm.getFormid();
    this.logger.info("formid:" + formid);
    FormNameBiz formNameBiz = new FormNameBiz();
    String tablename = formNameBiz.getTableNameByFormId(formid);
    RecordSet rs = new RecordSet();
    String sql = "select * from uf_tyhcpzb where id=" + this.confid + " and workflowid=" + workflowid;
    this.logger.info("sql:" + sql);
    rs.execute(sql);
    if (!rs.next()) {
      rm.setMessageid(requestid);
      rm.setMessagecontent("节点动作ActionMT_RESULT_REQ系统配置错误");
      return "0";
    } 
    String submitValue = rs.getString("submitValue");
    String rejectValue = rs.getString("rejectValue");
    sql = "select * from uf_tyhcpzb_dt1 where mainid=" + this.confid;
    rs.execute(sql);
    Map<String, String> fieldmap = new HashMap<>();
    while (rs.next())
      fieldmap.put(rs.getString("jkzdm"), rs.getString("lczdm")); 
    sql = "select * from " + tablename + " where requestid=" + requestid;
    rs.execute(sql);
    rs.next();
    Map<String, String> sysData = new HashMap<>();
    for (String jkzdm : fieldmap.keySet()) {
      String lczdm = fieldmap.get(jkzdm);
      String value = lczdm.startsWith("[default]") ? lczdm.substring("[default]".length()) : Util.null2String(rs.getString(lczdm));
      sysData.put(jkzdm, value);
    } 
    try {
      String requestXml = getRequestXml(rm, requestInfo.getRequestLog(), sysData, workflowid, requestid, rm.getSrc().equals("reject") ? rejectValue : submitValue);
      String endpoint = getPropValue("yksap", "sapendpoint");
      String username = getPropValue("yksap", "sapusername");
      String password = getPropValue("yksap", "sappassword");
      this.logger.info("endpoint=" + endpoint);
      this.logger.info("username=" + username);
      this.logger.info("password=" + password);
      String string = SapUtil.Soap11(endpoint, requestXml, username, password);
      this.logger.info("接口返回=" + string);
      if (!string.contains("<ZTYPE>S</ZTYPE>")) {
        rm.setMessageid(requestid);
        rm.setMessagecontent("接口调用报错：" + StringEscapeUtils.escapeHtml(string));
        return "0";
      } 
    } catch (Exception e) {
      e.printStackTrace();
      rm.setMessageid(requestid);
      rm.setMessagecontent("节点动作ActionMT_RESULT_REQ出现异常：" + e.getMessage());
      return "0";
    } 
    return "1";
  }
  
  private String getRequestXml(RequestManager requestManager, RequestLog requestLog, Map<String, String> sysData, String workflowid, String requestid, String ZWFSTU) throws Exception {
    MT_RESULT_REQ mt_result_req = new MT_RESULT_REQ();
    mt_result_req.setSYSID("OA");
    if (sysData.containsKey("IFYWID"))
      mt_result_req.setIFYWID(sysData.get("IFYWID")); 
    if (sysData.containsKey("BSKEY"))
      mt_result_req.setBSKEY(sysData.get("BSKEY")); 
    if (sysData.containsKey("SAPKEY"))
      mt_result_req.setSAPKEY(sysData.get("SAPKEY")); 
    if (sysData.containsKey("ZDATA"))
      mt_result_req.setZDATA(sysData.get("ZDATA")); 
    if (sysData.containsKey("ZFILED1"))
      mt_result_req.setZFILED1(sysData.get("ZFILED1")); 
    if (sysData.containsKey("ZFILED2"))
      mt_result_req.setZFILED2(sysData.get("ZFILED2")); 
    if (sysData.containsKey("ZFILED3"))
      mt_result_req.setZFILED3(sysData.get("ZFILED3")); 
    if (sysData.containsKey("ZFILED4"))
      mt_result_req.setZFILED4(sysData.get("ZFILED4")); 
    if (sysData.containsKey("ZFILED5"))
      mt_result_req.setZFILED5(sysData.get("ZFILED5")); 
    if (sysData.containsKey("ZORG"))
      mt_result_req.setZORG(sysData.get("ZORG")); 
    REQUEST_INFO request_info = new REQUEST_INFO();
    request_info.setZWFID(workflowid);
    request_info.setZWFSNO(requestid);
    request_info.setZWFSTU(ZWFSTU);
    String remark = requestManager.getRemark();
    if (remark.contains("remark") && remark.contains("remarkquote"))
      remark = ""; 
    request_info.setZWFTXT(Util.delHtmlWithSpace(Util.null2String(remark)).replaceAll("&dt;", "").replaceAll("&at;", ""));
    mt_result_req.setREQUEST_INFO(request_info);
    ResourceComInfo resourceComInfo = new ResourceComInfo();
    DepartmentComInfo departmentComInfo = new DepartmentComInfo();
    WorkflowNodeComInfo workflowNodeComInfo = new WorkflowNodeComInfo();
    List<REQUEST_LOG> request_logs = new ArrayList<>();
    Log[] logs = requestLog.getLog();
    RecordSet rs = new RecordSet();
    for (Log log : logs) {
      String ZNODID = log.getNodeid();
      String ZNODTX = log.getNode();
      String ZWFSTU2 = log.getOptype();
      if (ZWFSTU2.equals("3")) {
        ZWFSTU2 = "04";
      } else {
        ZWFSTU2 = "02";
      } 
      String ZOPDAT = log.getOpdate().replace("-", "");
      String ZOPTIM = log.getOptime().replace(":", "");
      String ZOPTYP = log.getOptype();
      String ZOPNAM = log.getOperatorid();
      String ZOPNAMT = resourceComInfo.getLastname(ZOPNAM);
      String ZOPDEP = resourceComInfo.getDepartmentID(ZOPNAM);
      ZOPDEP = departmentComInfo.getDepartmentname(ZOPDEP);
      String ZOPSIGN = log.getComment();
      if (ZOPSIGN.contains("remark") && ZOPSIGN.contains("remarkquote"))
        ZOPSIGN = ""; 
      String ismobile = getIsMobile(log.getId());
      if (ismobile.equals("g"))
        ZOPSIGN = "前一节点已审批，系统自动批准"; 
      ZOPSIGN = Util.delHtmlWithSpace(ZOPSIGN).replaceAll("&dt;", "").replaceAll("&at;", "");
      String str1 = "select receivedate,receivetime from workflow_currentoperator where requestid=" + requestid + " and nodeid=" + ZNODID + " and userid=" + ZOPNAM;
      rs.execute(str1);
      rs.next();
      String str2 = Util.null2String(rs.getString(1)).replace("-", "");
      String str3 = Util.null2String(rs.getString(2)).replace(":", "");
      str1 = "select userid from workflow_currentoperator where nodeid in (select destnodeid from workflow_requestlog where requestid='" + requestid + "' and nodeid='" + ZNODID + "') and requestid=" + requestid;
      rs.execute(str1);
      rs.next();
      String ZNXNAM = rs.getString(1);
      String ZNXNAMT = resourceComInfo.getLastname(ZNXNAM);
      REQUEST_LOG rEQUEST_LOG = new REQUEST_LOG();
      rEQUEST_LOG.setZNODID(ZNODID);
      rEQUEST_LOG.setZNODTX(ZNODTX);
      rEQUEST_LOG.setZWFSTU(ZWFSTU2);
      rEQUEST_LOG.setZRVDAT(str2);
      rEQUEST_LOG.setZRVTIM(str3);
      rEQUEST_LOG.setZOPDAT(ZOPDAT);
      rEQUEST_LOG.setZOPTIM(ZOPTIM);
      rEQUEST_LOG.setZOPTYP(ZOPTYP);
      rEQUEST_LOG.setZOPDEP(ZOPDEP);
      rEQUEST_LOG.setZOPNAM(ZOPNAM);
      rEQUEST_LOG.setZOPNAMT(ZOPNAMT);
      rEQUEST_LOG.setZOPSIGN(ZOPSIGN);
      rEQUEST_LOG.setZNXNAM(ZNXNAM);
      rEQUEST_LOG.setZNXNAMT(ZNXNAMT);
      request_logs.add(rEQUEST_LOG);
    } 
    SimpleDateFormat sdf1 = new SimpleDateFormat("yyyyMMdd");
    SimpleDateFormat sdf2 = new SimpleDateFormat("HHmmss");
    Date date = new Date();
    REQUEST_LOG request_log = new REQUEST_LOG();
    request_log.setZNODID(requestManager.getNodeid() + "");
    request_log.setZNODTX(workflowNodeComInfo.getNodename(requestManager.getNodeid() + ""));
    request_log.setZWFSTU(requestManager.getSrc().equals("reject") ? "04" : "03");
    String sql = "select receivedate,receivetime from workflow_currentoperator where requestid=" + requestid + " and nodeid=" + requestManager.getNodeid() + " and userid=" + requestManager.getUserId();
    rs.execute(sql);
    rs.next();
    String ZRVDAT = Util.null2String(rs.getString(1)).replace("-", "");
    String ZRVTIM = Util.null2String(rs.getString(2)).replace(":", "");
    request_log.setZRVDAT(ZRVDAT);
    request_log.setZRVTIM(ZRVTIM);
    request_log.setZOPDAT(sdf1.format(date));
    request_log.setZOPTIM(sdf2.format(date));
    request_log.setZOPTYP(requestManager.getSrc().equals("reject") ? "04" : "03");
    request_log.setZOPDEP(departmentComInfo.getDepartmentname(resourceComInfo.getDepartmentID(requestManager.getUserId() + "")));
    request_log.setZOPNAM(requestManager.getUserId() + "");
    request_log.setZOPNAMT(resourceComInfo.getLastname(requestManager.getUserId() + ""));
    request_log.setZOPSIGN(Util.delHtmlWithSpace(Util.null2String(remark)).replaceAll("&dt;", "").replaceAll("&at;", ""));
    request_log.setZNXNAM("");
    request_log.setZNXNAMT("");
    request_logs.add(request_log);
    mt_result_req.setREQUEST_LOG(request_logs.<REQUEST_LOG>toArray(new REQUEST_LOG[0]));
    return toXml(mt_result_req);
  }
  
  private String toXml(MT_RESULT_REQ mt_result_req) {
    StringBuilder sb = new StringBuilder();
    REQUEST_LOG[] logs = mt_result_req.getREQUEST_LOG();
    for (REQUEST_LOG log : logs) {
      String string = "         <REQUEST_LOG>\n            <ZNODID>" + Util.null2String(log.getZNODID()) + "</ZNODID>\n            <ZNODTX>" + Util.null2String(log.getZNODTX()) + "</ZNODTX>\n            <ZWFSTU>" + Util.null2String(log.getZWFSTU()) + "</ZWFSTU>\n            <ZRVDAT>" + Util.null2String(log.getZRVDAT()) + "</ZRVDAT>\n            <ZRVTIM>" + Util.null2String(log.getZRVTIM()) + "</ZRVTIM>\n            <ZOPDAT>" + Util.null2String(log.getZOPDAT()) + "</ZOPDAT>\n            <ZOPTIM>" + Util.null2String(log.getZOPTIM()) + "</ZOPTIM>\n            <ZOPTYP>" + Util.null2String(log.getZOPTYP()) + "</ZOPTYP>\n            <ZOPDEP>" + Util.null2String(log.getZOPDEP()) + "</ZOPDEP>\n            <ZOPNAM>" + Util.null2String(log.getZOPNAM()) + "</ZOPNAM>\n            <ZOPNAMT>" + Util.null2String(log.getZOPNAMT()) + "</ZOPNAMT>\n            <ZOPSIGN>" + Util.null2String(log.getZOPSIGN()) + "</ZOPSIGN>\n            <ZNXNAM>" + Util.null2String(log.getZNXNAM()) + "</ZNXNAM>\n            <ZNXNAMT>" + Util.null2String(log.getZNXNAMT()) + "</ZNXNAMT>\n         </REQUEST_LOG>\n";
      sb.append(string);
    } 
    String xml = "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:bpm=\"http://yk.com/oa/bpm\">\n   <soapenv:Header/>\n   <soapenv:Body>\n      <bpm:MT_RESULT_REQ>\n         <SYSID>" + Util.null2String(mt_result_req.getSYSID()) + "</SYSID>\n         <IFYWID>" + Util.null2String(mt_result_req.getIFYWID()) + "</IFYWID>\n         <BSKEY>" + Util.null2String(mt_result_req.getBSKEY()) + "</BSKEY>\n         <SAPKEY>" + Util.null2String(mt_result_req.getSAPKEY()) + "</SAPKEY>\n         <ZORG>" + Util.null2String(mt_result_req.getZORG()) + "</ZORG>\n         <ZFILED1>" + Util.null2String(mt_result_req.getZFILED1()) + "</ZFILED1>\n         <ZFILED2>" + Util.null2String(mt_result_req.getZFILED2()) + "</ZFILED2>\n         <ZFILED3>" + Util.null2String(mt_result_req.getZFILED3()) + "</ZFILED3>\n         <ZFILED4>" + Util.null2String(mt_result_req.getZFILED4()) + "</ZFILED4>\n         <ZFILED5>" + Util.null2String(mt_result_req.getZFILED5()) + "</ZFILED5>\n         <ZDATA><![CDATA[" + Util.null2String(mt_result_req.getZDATA()) + "]]></ZDATA>\n         <REQUEST_INFO>\n            <ZWFID>" + Util.null2String(mt_result_req.getREQUEST_INFO().getZWFID()) + "</ZWFID>\n            <ZWFSNO>" + Util.null2String(mt_result_req.getREQUEST_INFO().getZWFSNO()) + "</ZWFSNO>\n            <ZWFSTU>" + Util.null2String(mt_result_req.getREQUEST_INFO().getZWFSTU()) + "</ZWFSTU>\n            <ZWFTXT>" + Util.null2String(mt_result_req.getREQUEST_INFO().getZWFTXT()) + "</ZWFTXT>\n         </REQUEST_INFO>\n" + sb.toString() + "      </bpm:MT_RESULT_REQ>\n   </soapenv:Body>\n</soapenv:Envelope>";
    this.logger.info(xml);
    return xml;
  }
  
  private String getIsMobile(String logid) {
    RecordSet rs = new RecordSet();
    String sql = "select ismobile from workflow_requestlog where logid=" + logid;
    rs.execute(sql);
    rs.next();
    return Util.null2String(rs.getString(1));
  }
  
  private final Logger logger = LoggerFactory.getLogger();
  
  public String getConfid() {
    return this.confid;
  }
  
  public void setConfid(String confid) {
    this.confid = confid;
  }
}
